SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Exceptions'!
SystemOrganization addCategory: #'Xenon-Core'!

Object subclass: #XeCodeGenerator
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeCodeGenerator commentStamp: 'BernardoContreras 3/19/2012 22:14' prior: 0!
* Constants are translated only if they are binded in a method.
!

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/3/2012 21:14'!
addClass: aClass 
	classes add: aClass! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:31'!
annotatorClass
	^ XeAnnotator! !

!XeCodeGenerator methodsFor: 'public' stamp: 'BernardoContreras 4/3/2012 21:32'!
codeString
	| stream annotator |
	stream := ReadWriteStream on: (String new: 1000).
	annotator := self annotatorClass new.
	classes
		do: [ :aClass | 
			aClass
				methodsDo: [ :method | 
					| methodNode translator |
					methodNode := self parserClass parseMethod: method getSource.
					annotator visitNode: methodNode.
					translator := self translatorClass newFor: stream.
					translator visitNode: methodNode ] ].
	^ stream contents! !

!XeCodeGenerator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/3/2012 21:26'!
initialize
	super initialize.
	classes := OrderedCollection new! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/15/2012 23:09'!
parserClass
	^ RBParser! !

!XeCodeGenerator methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:38'!
translatorClass
	^ XeTranslator! !

Object subclass: #XeType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeType commentStamp: 'BernardoContreras 2/27/2012 19:07' prior: 0!
To describe types!

!XeType class methodsFor: 'instance creation' stamp: 'BernardoContreras 3/25/2012 03:55'!
name: aString 
	^ self new name: aString.! !

!XeType methodsFor: 'emit code' stamp: 'BernardoContreras 3/25/2012 03:57'!
emitOn: aStream
	"emit the string representation of this type on a stream"

	aStream nextPutAll: name! !

!XeType methodsFor: 'accessing' stamp: 'BernardoContreras 3/25/2012 03:56'!
name: aString 
	name := aString! !

Object subclass: #XeTypes
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes commentStamp: 'BernardoContreras 3/20/2012 00:19' prior: 0!
Hold all defined types!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes class methodsFor: 'singleton' stamp: 'BernardoContreras 3/19/2012 23:57'!
default
	^ default ifNil: [ default := self new ]! !

!XeTypes class methodsFor: 'class initialization' stamp: 'BernardoContreras 3/20/2012 00:04'!
initialize
	default := nil! !

!XeTypes class methodsFor: 'cleanup' stamp: 'BernardoContreras 3/19/2012 23:58'!
reset
	"XeTypes reset"

	default := nil! !

!XeTypes methodsFor: 'accessing' stamp: 'BernardoContreras 3/25/2012 03:43'!
at: aSymbol
	^ types at: aSymbol ifAbsent: [ XeTypeNotFoundError signalFor: aSymbol ]! !

!XeTypes methodsFor: 'initialize-release' stamp: 'BernardoContreras 3/25/2012 03:54'!
initialize
	super initialize.
	types := Dictionary new.
	types at: #int put: (XeType name: 'int').
	types at: #void put: (XeType name: 'void').
	types at: #default put: (XeType name: 'sqInt')! !

RBProgramNodeVisitor subclass: #XeAnnotator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/5/2012 16:51'!
acceptPragmaNode: aPragmaNode
	aPragmaNode selector == #returnType: ifTrue: [
		aPragmaNode parent returnType: (aPragmaNode arguments first token value)
		].
	aPragmaNode selector == #var:type: ifTrue: [
		aPragmaNode parent declarations at: (aPragmaNode arguments first token value)
			put: (aPragmaNode arguments second token value asXeType)
		]! !

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/3/2012 00:14'!
acceptVariableNode: aVariableNode
	aVariableNode parent declarations at: aVariableNode name put: #default asXeType! !

RBProgramNodeVisitor subclass: #XeTranslator
	instanceVariableNames: 'stream indentationLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeTranslator commentStamp: 'BernardoContreras 4/5/2012 15:50' prior: 0!
To translate to C Code on a stream
!

!XeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 4/5/2012 15:49'!
newFor: aStream 
	" a new instance for the given stream"
	^ self new stream: aStream; yourself! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/5/2012 21:03'!
acceptLiteralNode: aLiteralNode
	self nextPutAll: (self cLiteralValueFor: aLiteralNode token)! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/5/2012 21:17'!
acceptMethodNode: aMethodNode
	aMethodNode returnType emitOn: stream.
	self space.
	self nextPutAll: aMethodNode cFunctionName.
	self nextPut: $(.
	self visitMethodArguments: aMethodNode arguments.
	self nextPut: $).
	self visitNode: aMethodNode body! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/5/2012 21:04'!
acceptReturnNode: aReturnNode
	self
		nextPutAll: 'return';
		space.
	self visitNode: aReturnNode value! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/5/2012 21:22'!
acceptSequenceNode: aSequenceNode
	self
		nextPut: ${;
		cr.
	self incrementIndentation.
	self visitArguments: aSequenceNode temporaries.
	aSequenceNode statements
		do: [ :each |
			self nextPutIndentation. 
			self visitNode: each.
			self
				nextPut: $;;
				cr ].
	self decrementIndentation.
	self
		nextPut: $};
		cr! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 4/5/2012 21:04'!
acceptVariableNode: aVariableNode
	(aVariableNode parent declarations at: aVariableNode name) emitOn: stream.
	self space.
	self nextPutAll: aVariableNode name! !

!XeTranslator methodsFor: 'private' stamp: 'BernardoContreras 4/5/2012 20:39'!
cLiteralValueFor: aRBLiteralToken 
	^ aRBLiteralToken value asString! !

!XeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/5/2012 21:06'!
cr
	stream cr! !

!XeTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/5/2012 21:11'!
decrementIndentation
	indentationLevel := indentationLevel - 1! !

!XeTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/5/2012 21:11'!
incrementIndentation
	indentationLevel := indentationLevel + 1! !

!XeTranslator methodsFor: 'initialize-release' stamp: 'BernardoContreras 4/5/2012 21:03'!
initialize
	super initialize.
	indentationLevel := 0! !

!XeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/5/2012 21:13'!
nextPut: anObject
	stream nextPut: anObject! !

!XeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/5/2012 21:22'!
nextPutAll: aCollection
	stream nextPutAll: aCollection! !

!XeTranslator methodsFor: 'private indentation' stamp: 'BernardoContreras 4/5/2012 21:23'!
nextPutIndentation
	stream tab: indentationLevel ! !

!XeTranslator methodsFor: 'private writing' stamp: 'BernardoContreras 4/5/2012 21:05'!
space
	stream space! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 3/16/2012 00:51'!
stream: aStream 
	stream := aStream! !

!XeTranslator methodsFor: 'visiting' stamp: 'BernardoContreras 4/3/2012 23:51'!
visitMethodArguments: aNodeCollection 
	^aNodeCollection do: [:each | self visitArgument: each] separatedBy: [ stream nextPutAll: ', ' ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/5/2012 15:47'!
cFunctionName
	"Create a C function name from the given selector by omitting colons"
	^ self selector copyWithout: $:
! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/3/2012 00:13'!
declarations
	^ self hasDeclarations
		ifTrue: [ self propertyAt: #declarations ]
		ifFalse: [ self propertyAt: #declarations put: Dictionary new ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/3/2012 00:07'!
hasDeclarations
	^ self hasProperty: #declarations! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:33'!
hasReturnType
	^ self hasProperty: #returnType! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 4/3/2012 00:13'!
returnType
	^ self hasReturnType
		ifTrue: [ (self propertyAt: #returnType) asXeType ]
		ifFalse: [ #default asXeType ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/25/2012 02:51'!
returnType: typename
	self hasReturnType
		ifTrue: [ 
			XeTooManyReturnTypesError
				signalForSelector: self selector
				returnTypes:
					{(self returnType).
					typename} ]
		ifFalse: [ self propertyAt: #returnType put: typename ]! !

!ByteSymbol methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/19/2012 23:18'!
asXeType
	^ XeTypes default at: self
	! !

Error subclass: #XeTooManyReturnTypesError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTooManyReturnTypesError commentStamp: 'BernardoContreras 2/27/2012 19:36' prior: 0!
When a selector in a class has defined too many return types.
A selector in a class should have only one return type.

!

!XeTooManyReturnTypesError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/25/2012 02:51'!
signalForSelector: aSelectorName returnTypes: anArray
	| message |
	message := 'Too many return types for method ' , aSelectorName , '. actual types: ' , anArray asString.
	^ self signal: message! !

Error subclass: #XeTypeNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTypeNotFoundError commentStamp: 'BernardoContreras 3/19/2012 23:49' prior: 0!
When a type is not found.
!

!XeTypeNotFoundError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/19/2012 23:43'!
signalFor: aSymbol 

	^ self signal: 'Couldn''t find type: ' , aSymbol.! !
XeTypes initialize!
